Imports System


Public Class DemoMethods

    <Ajax.AjaxMethod()> Public Function Test1(ByVal firstName As String, ByVal familyName As String, ByVal email As String, ByVal comment As String) As String

        Return "Hello " + firstName + " " + familyName + "<br>Thank you for your comment <b>" + System.Web.HttpUtility.HtmlEncode(comment) + "</b>."

    End Function


    <Ajax.AjaxMethod()> Public Function Test2(ByVal d As DateTime) As String

        d = d.AddDays(1)

        Return "The next day will be " + d.ToLongDateString() + "."

    End Function


    <Ajax.AjaxMethod()> Public Function Test3() As System.Data.DataSet

        Dim ds As System.Data.DataSet
        Dim dt As System.Data.DataTable
        Dim row As System.Data.DataRow

        ds = New System.Data.DataSet
        dt = New System.Data.DataTable

        dt.Columns.Add("Country", GetType(System.String))
        ds.Tables.Add(dt)

        ' fill sample data (i.e. can be replaced with database query)

        row = dt.NewRow()
        row("Country") = "Germany"
        dt.Rows.Add(row)

        row = dt.NewRow()
        row("Country") = "Austria"
        dt.Rows.Add(row)

        row = dt.NewRow()
        row("Country") = "Switzerland"
        dt.Rows.Add(row)

        row = dt.NewRow()
        row("Country") = "France"
        dt.Rows.Add(row)

        row = dt.NewRow()
        row("Country") = "Bavaria  ;)"
        dt.Rows.Add(row)

        Return ds

    End Function


    <Ajax.AjaxMethod()> Public Function Test4()

        Throw New System.Security.SecurityException("This user does not have access rights on this resource.")

    End Function


    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.ReadWrite)> Public Function Test5(ByVal value As String)

        System.Web.HttpContext.Current.Session("test") = value

    End Function


    <Ajax.AjaxMethod(Ajax.HttpSessionStateRequirement.Read)> Public Function Test6() As String

        If System.Web.HttpContext.Current.Session("test") <> Nothing Then
            Return System.Web.HttpContext.Current.Session("test").ToString()
        End If

        Return "First set the value..."

    End Function


    <Ajax.AjaxMethod()> Public Function Test7()

        Dim c As Int32
        c = 0

        Do

            System.Threading.Thread.Sleep(1000)
            c = c + 1

        Loop While (c < 10)

    End Function


    <Ajax.AjaxMethod()> Public Function Test8() As Integer

        Dim r As Random
        r = New Random(System.DateTime.Now.Second)
        Return r.Next(0, 100)

    End Function

    <Ajax.AjaxMethod()> Public Function Test14() As Appointment

        Dim _a As Appointment
        _a = New Appointment

        Return _a

    End Function

End Class



<Serializable()> Public Class Appointment
    Implements IComparable

    Dim _ScheduleID As Integer = -1
    Dim _StartTime As DateTime = Now
    Dim _EndTime As DateTime = Now
    Dim _PatientComments As String = ""

    Public ReadOnly Property PatientComments() As String
        Get
            Return _PatientComments
        End Get
    End Property

    Public ReadOnly Property EndTime() As DateTime
        Get
            Return _EndTime
        End Get
    End Property

    Public ReadOnly Property StartTime() As DateTime
        Get
            Return _StartTime
        End Get
    End Property

    Public ReadOnly Property ScheduleID() As Integer
        Get
            Return _ScheduleID
        End Get
    End Property

    Public Overloads Function CompareTo(ByVal obj As Object) As Integer _
        Implements IComparable.CompareTo

        If TypeOf obj Is Appointment Then
            Return True
        End If

        Throw New ArgumentException("object is not a Appointment")
    End Function
End Class

