function callback_test1(res)
{
	document.getElementById("display1").innerHTML = res.value;
}

function test1()
{
	DemoMethods.Test1(
		document.getElementById("firstName").value, 
		document.getElementById("familyName").value,
		document.getElementById("email").value,
		document.getElementById("comment").value,
		callback_test1
		);
}

function callback_test2(res)
{
	document.getElementById("display2").innerHTML = res.value;
}

function test2()
{
	var d = null;

	try	
	{
		d = new DateTime(
			document.getElementById("year").value,
			document.getElementById("month").value,
			document.getElementById("day").value,
			0, 0, 0
			);
		
		DemoMethods.Test2(d, callback_test2);
	}
	catch(e)
	{
		alert("Error: " + e.description);
	}
}

function callback_test3(res)
{
	if(res != null && res.value != null && res.value.Tables != 0 && res.value.Tables.length == 1)
	{
		var html = [];
		
		for(var i=0; i<res.value.Tables[0].Rows.length; i++)
			html[html.length] = "<option>" + res.value.Tables[0].Rows[i].Country + "</option>";
	
		document.getElementById("display3").innerHTML = "<select>" + html.join("") + "</select>";
	}
}

function test3()
{
	DemoMethods.Test3(callback_test3);
}

function test4()
{
	var res = DemoMethods.Test4();
	if(res.error != null) alert(res.error);
}

function test5()
{
	DemoMethods.Test5(document.getElementById("sessionTest1").value);
}

function callback_test6(res)
{
	document.getElementById("sessionTest2").value = res.value;
}

function test6()
{
	DemoMethods.Test6(callback_test6);
}

function callback_test7(res)
{
	alert("The server has finished the 10 seconds call, now!");
}

function test7()
{
	DemoMethods.Test7(callback_test7);
}

function test8(ele)
{
	DemoMethods.Test8(test8_callback, ele);  // the server-side method has no arguments!
}

function test8_callback(res)
{
	if(res.error == null && res.context != null)
		res.context.innerHTML = res.value;
}

function test11()
{
	DemoMethods.Test11(test11_callback);
}

function test11_callback(res)
{
	if(res.value[2])							// bolean
		alert(res.value[1].toLocaleString());	// date
		
	alert(res.value[3].FirstName + " + " + res.value[4].FirstName);
}

function test12()
{
	DemoMethods.Test12(test12_callback);
}

function test12_callback(res)
{
	var s = res.value.FirstName + " " + res.value.FamilyName + ":\r\n";
	
	for(var i=0; i<res.value.Children.length; i++)
		s += "\t" + res.value.Children[i].FirstName + "\r\n";
	
	alert(s);
}

function test13()
{
	// call the Ajax.NET method on the server to get
	// a new news ticker object
  
	DemoMethods.Test13(test13_callback);
}

function test13_callback(res)
{
	if(typeof(res.value) == 'object')
	{
		// display the news ticker
    
		document.getElementById('newsticker').innerHTML = '<a href="' + res.value.URL + '">' + res.value.Text + '</a>';
		window.setTimeout(test13, res.value.Duration * 1000);
	}
}

function test16()
{
	DemoMethods.Test16(test16_callback);
}

function test16_callback(res)
{
	if(typeof(res.value) == 'object')
	{
		document.getElementById("imageholder").innerHTML = '';
		document.getElementById("imageholder").appendChild(res.value);
	}
}

function test17(n)
{
    // n will be a array of numbers/integer

	if(typeof(n) != 'object') return;
	alert(DemoMethods.Test17(n).value);
}

function test18()
{
	alert(DemoMethods.Test18( ["aaaa","bbbb","ccc\"ccccc"] ).value);
}

function test19(ele, car)
{
	HtmlControlUpdate('DemoMethods.Test19', 'dropDisplay', car);
}

function test20()
{
	return DemoMethods.Test20().value;
}

function test21(controlHolderId, id)
{
	HtmlControlUpdate('DemoMethods.Test21', controlHolderId, new HtmlControl(id));
}

window.attachEvent("onload", test13);
