function callback_test1(res)
{
	document.getElementById("display1").innerHTML = res.value;
}

function test1()
{
	DemoMethods.Test1(
		document.getElementById("firstName").value, 
		document.getElementById("familyName").value,
		document.getElementById("email").value,
		document.getElementById("comment").value,
		callback_test1
		);
}


function callback_test2(res)
{
	document.getElementById("display2").innerHTML = res.value;
}

function test2()
{
	var d = null;
	
	try
	{
		d = new DateTime(
			document.getElementById("year").value,
			document.getElementById("month").value,
			document.getElementById("day").value,
			0, 0, 0
			);
	
		
		DemoMethods.Test2(d, callback_test2);
	}
	catch(e)
	{
		alert("Error: " + e.description);
	}
}


function callback_test3(res)
{
	if(res != null && res.value != null && res.value.Tables != 0 && res.value.Tables.length == 1)
	{
		var html = [];
		
		for(var i=0; i<res.value.Tables[0].Rows.length; i++)
			html[html.length] = "<option>" + res.value.Tables[0].Rows[i].Country + "</option>";
	
		document.getElementById("display3").innerHTML = "<select>" + html.join("") + "</select>";
	}
}

function test3()
{
	DemoMethods.Test3(callback_test3);
}

function test4()
{
	var res = DemoMethods.Test4();
	if(res.error != null) alert(res.error);
}

function test5()
{
	DemoMethods.Test5(document.getElementById("sessionTest1").value);
}

function callback_test6(res)
{
	document.getElementById("sessionTest2").value = res.value;
}

function test6()
{
	DemoMethods.Test6(callback_test6);
}

function callback_test7(res)
{
	alert("The server has finished the 10 seconds call, now!");
}

function test7()
{
	DemoMethods.Test7(callback_test7);
}

function test8(ele)
{
	DemoMethods.Test8(test8_callback, ele);  // the server-side method has no arguments!
}

function test8_callback(res)
{
	if(res.error == null && res.context != null)
		res.context.innerHTML = res.value;
}